* 7-8 Feb 02: some optimizations and real*8 fudge (have used it
*             successfully up to n=16)
* 9 Feb 02:   arbitrary length integer arithmetic replaces real*8
* 9-10 Feb 02:group the factors in MKTERM
* 10 Feb 02:  allow calculation to be stopped and restarted.
* 11 Feb 02:  bug fix -- all results now counted!!
* 12 Feb 02:  array(*) declarations
      program run20
      implicit none
      integer maxn, max2n, maxlen
      parameter (maxn = 20, max2n = (2*maxn), maxlen = 20)
      integer start, saved, j
      integer n, twon, x(max2n), sum(maxlen), term(maxlen)
      real t0, t1, t2

      n = 20
      twon = 2*n

      saved = -1
      open(unit=9,file='restart.txt',status='old',err=10)
      read(9,*) saved
      close(9)
      
      print*,'Last saved case was:', saved
 10   start = -1
      do while (start.lt.0 .or. start.gt.1023)
         print*,'Where do you want to restart from (e.g.,',saved+1,')?'
         read(*,*) start
      end do
      

      call clock@(t0)
      print*,'Use CTRL-C to stop ... calculation can be restarted'
      do while (start .le. 1023)
         call clock@(t1)
         call lang(start,x,twon,sum,term,maxlen)
         call clock@(t2)

         open(unit=8,file='results.txt',status='unknown')
         call go2end(8)
         write(8,'(" Case: ",i4,"    Time (sec):",f9.2)')start,t2-t1
         write(8,'(10i6)') (sum(j),j=1,10)
         write(8,'(10i6)') (sum(j),j=11,20)
         close(8)
         print'(" Case: ",i4,"    Time (sec):",f9.2)',start,t2-t1
         print'(10i6)', (sum(j),j=1,10)
         print'(10i6)', (sum(j),j=11,20)         
         
         open(unit=9,file='restart.txt',status='unknown')
         write(9,*) start
         close(9)

         start = start+1
      end do
      print*,'Total time:',(t2-t0)

      end


      subroutine go2end(iunit)
      integer iunit
      do while(.true.)
         read(unit=iunit,fmt=*,end=10)
      end do
 10   return
      end

      subroutine lang(start,x,twon,sum,term,maxlen)
      implicit none
      integer start, twon, maxlen
      integer x(twon), sum(maxlen), term(maxlen)
      integer n, dep, sgn, lentrm, i, m, depred, enddep
      logical zero
* definitions for two statement-functions:
      integer nexmov
      logical nomore
      nomore(m) = x(m).eq.0
      nexmov(m) = mod(m+2,3)-1

      n = twon/2

* depth at which reduction of SUM occurs:
      depred = max(twon-13,1)

* Initialize variables
      call setup(start,x,dep,sgn,twon)
      enddep = dep-1
      do i = 1, maxlen
         sum(i) = 0
      end do
      
 10   x(dep) = nexmov(x(dep))
      if (nomore(dep)) then 
* backtrack to previous depth      
         dep = dep-1
         sgn = -sgn
* would normally return from here:         
         if (dep .eq. enddep) then
            call reduce(sum,maxlen)
            return
         end if
         if (dep .eq. depred) call reduce(sum,maxlen)
      else 
         sgn = sgn*x(dep)
         if (dep .eq. twon) then
* evaluate new term ... include in sum
C            print'(24i2)',x
            call mkterm(x,twon,term,lentrm,zero)
            if (.not.zero) call add(sum,term,sgn,lentrm)
         else 
* go deeper into tree
            dep = dep+1
            x(dep) = 0
         end if
      end if
      go to 10

      end
      

      subroutine setup(start,x,dep,sgn,twon)
      implicit none
      integer twon, start, dep, sgn
      integer x(twon)
      
      integer i, temp
      x(1) = 1
      temp = start
      sgn = 1
      do i = 11, 2, -1
         x(i) = 1 - 2*mod(temp,2)
         sgn = sgn*x(i)
         temp = temp/2
      end do
      dep = 12
      x(dep) = 0
      end


      subroutine mkterm(x,twon,term,big,zero)
      implicit none
      integer twon, big
      integer x(*), term(*)
      logical zero
      
      integer i, j, n, maxn, base, prod
      parameter (maxn = 20, base = 10000)
      integer fac(maxn)
      
      n = twon/2
      do i = n, 1, -1
         fac(i) = 0
         do j = twon-i-1, 1, -1
            fac(i) = fac(i) + x(j)*x(j+i+1)
         end do
         if (fac(i) .eq. 0) then
            zero = .true.
            return
         end if
      end do

* now accumulate products of factors, to a limit of BASE
* (so as to minimize number of calls to MULT!)
      zero = .false.
      big = 1
C      term(1) = 1
C      do i = n, 1, -1
C         call mult(term,big,maxlen,fac(i))
C      end do
C      return
      prod = fac(n)
      do i = n-1, 1, -1
* assumption here is that 2n is not too large -- start from temp=1
* in general!  But this is all right up to n=20.
         prod = prod*fac(i)
         if (abs(prod).ge.base) then
            term(1) = prod/fac(i)
            prod = fac(i)
            j = i
            go to 10
         end if
      end do

* that loop DOES sometimes complete, so...
      term(1) = 1
      call mult(term,big,prod)
      return

 10   do i = j-1, 1, -1
* same assumption as above:
         prod = prod*fac(i)
         if (abs(prod).ge.base) then
            prod = prod/fac(i)
            call mult(term,big,prod)
            prod = fac(i)
         end if
      end do

      call mult(term,big,prod)

      end
      
*** routines for dealing with big integers ***
      
      subroutine mult(num,len,fac)
      implicit none
      integer len, fac
      integer num(*)
* multiplication of NUM by FAC
      integer base
      parameter (base = 10000)
      integer carry, i, temp
      
      carry = 0
      do i = 1, len
         temp = num(i)*fac + carry
         num(i) = mod(temp,base)
         carry = temp/base
      end do
      
      if (carry .ne. 0) then
         len = len+1
* feeling confident enough to omit this check:
C         if (len .gt. maxlen) then
C            print*,'Overflow in MULT'
C            stop
C         end if
         num(len) = carry
      end if

      end
      

      subroutine add(sum,trm,sgntrm,lentrm)
      implicit none
      integer sum(*),trm(*),lentrm,sgntrm
* simple addition of TRM to SUM.  Carry-overs are sorted out
* separately.
      integer i

      do i = 1, lentrm
         sum(i) = sum(i) + sgntrm*trm(i)
      end do

      end

      
      subroutine reduce(sum,maxlen)
      implicit none
      integer maxlen
      integer sum(maxlen)
* every so often it is useful to reduce the size of the terms in SUM
      integer i, carry, temp, base
      parameter (base = 10000)

      carry = 0
      do i = 1, maxlen
         temp = sum(i) + carry
         carry = temp/base
         sum(i) = mod(temp,base)
      end do
      
      end
      

      subroutine final(sum,maxlen,twon)
      implicit none
      integer maxlen, twon
      integer sum(maxlen)
* prepare for output -- make all signs positive and divide by 2^twon
      integer i, j, temp, carry, base
      parameter (base = 10000)      

* first have reduce all terms to range -base+1 to base-1
      call reduce(sum,maxlen)
      
      carry = 0
      do i = 1, maxlen-1
         if (sum(i) .lt. 0) then
            sum(i) = sum(i) + base
            sum(i+1) = sum(i+1) - 1
         end if
      end do

* now do the divisions by 2
      do i = 1, twon
         carry = 0
         do j = maxlen, 1, -1
            temp = sum(j) + base*carry
            sum(j) = temp/2
            carry = mod(temp,2)
         end do
      end do
      
      end
      

      subroutine prnsum(sum,maxlen)
      implicit none
      integer maxlen
      integer sum(maxlen)
      
      integer i, lensum
      lensum = maxlen
      do while(sum(lensum) .eq. 0)
         lensum = lensum-1
      end do
      
      print'(i4,50i1)',sum(lensum),
     &              (mod(sum(i)/1000,10),
     &               mod(sum(i)/100,10),
     &               mod(sum(i)/10,10),
     &               mod(sum(i),10), i = lensum-1, 1, -1)

      end
